import IMask, { InputMask, MaskElement } from "imask";
import AnyMaskedOptions = IMask.AnyMaskedOptions;
import { ChangeEvent, RefObject } from "react";
export declare type UseIMaskReturnValue<M extends AnyMaskedOptions, E extends HTMLElement | MaskElement = HTMLInputElement> = [
/**
 * apply this to input you want to mask
 */
RefObject<E>, 
/**
 * ref with IMask object
 */
RefObject<InputMask<M> | undefined>];
export declare type IMaskHandlers<M extends AnyMaskedOptions, E extends HTMLElement | MaskElement = HTMLInputElement> = {
    onAccept?: (e: ChangeEvent<E>, mask: InputMask<M> | undefined) => void;
    onComplete?: (e: ChangeEvent<E>, mask: InputMask<M> | undefined) => void;
};
export declare function useIMask<M extends AnyMaskedOptions, E extends HTMLElement | MaskElement = HTMLInputElement>(options: M, { onAccept, onComplete }?: IMaskHandlers<M, E>): UseIMaskReturnValue<M, E>;
