'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var IMask = _interopDefault(require('imask'));
var react = require('react');

function useIMask(options, _temp) {
  var _ref = _temp === void 0 ? {} : _temp,
      onAccept = _ref.onAccept,
      onComplete = _ref.onComplete;

  var ref = react.useRef(null);
  var maskRef = react.useRef();
  var acceptRef = react.useRef(onAccept);
  var completeRef = react.useRef(onComplete);
  react.useEffect(function () {
    acceptRef.current = onAccept;
  }, [onAccept]);
  react.useEffect(function () {
    completeRef.current = onComplete;
  }, [onComplete]);
  react.useEffect(function () {
    if (ref.current) {
      if (maskRef.current) {
        var _maskRef$current;

        (_maskRef$current = maskRef.current) == null ? void 0 : _maskRef$current.updateOptions(options);
      } else {
        maskRef.current = IMask(ref.current, options);
      }
    }
  }, [options]);
  react.useEffect(function () {
    if (maskRef.current && acceptRef.current) {
      maskRef.current.on("accept", function (e) {
        return acceptRef.current == null ? void 0 : acceptRef.current(e, maskRef.current);
      });
    }
  }, []);
  react.useEffect(function () {
    if (maskRef.current && completeRef.current) {
      var _maskRef$current2;

      (_maskRef$current2 = maskRef.current) == null ? void 0 : _maskRef$current2.on("complete", function (e) {
        return completeRef.current == null ? void 0 : completeRef.current(e, maskRef.current);
      });
    }
  }, []);
  react.useEffect(function () {
    return function () {
      var _maskRef$current3;

      (_maskRef$current3 = maskRef.current) == null ? void 0 : _maskRef$current3.destroy();
    };
  }, []);
  return [ref, maskRef];
}

exports.useIMask = useIMask;
//# sourceMappingURL=use-imask.cjs.development.js.map
