import IMask from 'imask';
import { useRef, useEffect } from 'react';

function useIMask(options, _temp) {
  var _ref = _temp === void 0 ? {} : _temp,
      onAccept = _ref.onAccept,
      onComplete = _ref.onComplete;

  var ref = useRef(null);
  var maskRef = useRef();
  var acceptRef = useRef(onAccept);
  var completeRef = useRef(onComplete);
  useEffect(function () {
    acceptRef.current = onAccept;
  }, [onAccept]);
  useEffect(function () {
    completeRef.current = onComplete;
  }, [onComplete]);
  useEffect(function () {
    if (ref.current) {
      if (maskRef.current) {
        var _maskRef$current;

        (_maskRef$current = maskRef.current) == null ? void 0 : _maskRef$current.updateOptions(options);
      } else {
        maskRef.current = IMask(ref.current, options);
      }
    }
  }, [options]);
  useEffect(function () {
    if (maskRef.current && acceptRef.current) {
      maskRef.current.on("accept", function (e) {
        return acceptRef.current == null ? void 0 : acceptRef.current(e, maskRef.current);
      });
    }
  }, []);
  useEffect(function () {
    if (maskRef.current && completeRef.current) {
      var _maskRef$current2;

      (_maskRef$current2 = maskRef.current) == null ? void 0 : _maskRef$current2.on("complete", function (e) {
        return completeRef.current == null ? void 0 : completeRef.current(e, maskRef.current);
      });
    }
  }, []);
  useEffect(function () {
    return function () {
      var _maskRef$current3;

      (_maskRef$current3 = maskRef.current) == null ? void 0 : _maskRef$current3.destroy();
    };
  }, []);
  return [ref, maskRef];
}

export { useIMask };
//# sourceMappingURL=use-imask.esm.js.map
